#ifndef _PARSER_HPP_
#define _PARSER_HPP_

#include <string>
#include <set>
#include <map>

class PNode{
public:
    std::string sname;   //species name
    double weight;  //mutation weight

    PNode *lsub;
    PNode *rsub;

    int cost;
    std::set<int> label;

    PNode();
    PNode(std::string, double);

    ~PNode();

    void show(int indent=0);
private:
    PNode& operator=(const PNode& rhs);     //disable assignment operation
};

typedef std::map<std::string, int> Leaf_map;

int acid2int(const char);   //transform acids to int
int BP2int(std::string);         //transform basepair to int

std::string getPair(std::string, int, int);

int readCW(std::string, std::map<std::string,std::string>&);
int readNewick(std::string, PNode*);
#endif
