#include "parser.hpp"

#include <set>
#include <algorithm>

using namespace std;

void fitch_forward(PNode* root, Leaf_map& lm){
    set<int> label;
    if(root->lsub==0 and root->rsub==0){
        root->label.clear();
        root->label.insert(lm[root->sname]);
        root->cost=0.;
    }
    else{
        fitch_forward(root->lsub, lm);
        fitch_forward(root->rsub, lm);

        if(root->lsub->label.count(0)!=0){
            root->lsub->label=root->rsub->label;
        }
        if(root->rsub->label.count(0)!=0){
            root->rsub->label=root->lsub->label;
        }

        set_intersection(root->lsub->label.begin(), root->lsub->label.end(),
                         root->rsub->label.begin(), root->rsub->label.end(), inserter(label, label.end()));

        if(label.size()==0){
            set_union(root->lsub->label.begin(), root->lsub->label.end(),
                      root->rsub->label.begin(), root->rsub->label.end(), inserter(label, label.end()));
            root->label=label;
            root->cost=root->lsub->cost+root->rsub->cost+1;
        }
        else{
            root->label=label;
            root->cost=root->lsub->cost+root->rsub->cost;
        }
    }
}

